#ifndef _plateDetection_h_included_
#define _plateDetection_h_included_

/******************************************************************************
* INCLUDES                                                                    *
******************************************************************************/

//#include "plate.h"
#include <cv.h>
#include <highgui.h>
//#include <stdio.h>
//#include <time.h>
//#include <math.h>
//#include <string.h>

/******************************************************************************
* DEFINITIONS                                                                 *
******************************************************************************/



/******************************************************************************
* TYPEDEF                                                                     *
******************************************************************************/



/******************************************************************************
* GLOBAL DECLARATIONS                                                         *
******************************************************************************/

int   dim_x, dim_y;           //variabili globali per le costanti L e N e per le dimensioni della fotografia
char  filename_out[100];            //array con il nome della mask da salvare

uchar *imageData;

uchar *src_image[6];                   //copie dell'immagine originale
uchar *image[9];

uchar *half;                        //array di supporto per le operazioni da fare sulla foto
uchar *end_out;                     //array di supporto

uchar *white;                       //array in cui si memorizza la white mask
uchar *black;                       //array in cui si memorizza la black mask
uchar *gradient;                    //array in cui si memorizza la gradient mask
uchar *corner;                      //array in cui si memorizza la corner mask
uchar *stroke;                      //array in cui si memorizza la stroke mask
uchar *merging;                     //array in cui si memorizza la merging mask
uchar *final;                       //array in cui si memorizza la final mask
uchar *binarized;                   //array in cui si memorizza la binarized mask
uchar *thresholding;                //array in cui si memorizza la thresholding mask
uchar *equalized;                   //array in cui si memorizza l'immagine equalizzata
uchar *convoluted;                  //array in cui si memorizza l'immagine convoluta
uchar *floodfill;                   //array in cui si memorizza l'operazione di flood fill

uchar *closure_binarized;           //array in cui si memorizza la closure di un'immagine binaria
uchar *closure_binarized_dilate;    //array in cui si memorizza la dilation di un'immagine binaria
uchar *selection;                   //array un cui si memorizza la selezione della targa
uchar *outputs;

/******************************************************************************
* FUNCTIONS' PROTOTYPES                                                       *
******************************************************************************/


#endif
